Subject: bug#71822: Feature request: fullwidth to halfwidth

From: Eli Zaretskii <[email-masked]>
Date: Sat, 15 Mar 2025 14:00:43 +0200

> Date: Wed, 12 Mar 2025 07:38:59 +0900
> From: Kazuhiro Ito <[email-masked]>
> Cc: [email-masked], [email-masked]
> 
> > > > I eventually decided to write new commands, because the above
> > > > japanese-* commands are too specific to the Japanese users: for
> > > > example, they convert kana characters as well.
> > > > 
> > > > So there are now new commands fullwidth-region, fullwidth-word,
> > > > halfwidth-region, and halfwidth-word, which will be in Emacs 31 when
> > > > it is released.
> > > 
> > > New functions don't seem to handle SPACE (U+0020, ' ') and IDEOGRAPHIC
> > > SPACE (U+3000, '　').  U+3000 is used as fullwidth space in CJK
> > > languages.
> > 
> > That's because I didn't know people will want to convert those as part
> > of this feature, and so didn't include them in the translation table.
> > 
> > Is it true that most/all people who type fullwidth characters will
> > also type U+3000 instead of an ASCII SPC character?  If so, I will add
> > them to the translation table; it's easy.  But if some users would
> > like to leave SPC alone, maybe we should have some optional behavior
> > or something.
> 
> Though I rarely type fullwidth ASCII characters, most Japanese input
> methods enable user to input U+3000 via simply typing SPC.  So, U+3000
> is often used as alternate of ASCII SPACE.
> 
> U+3000 may be used as an indent at the beginning of Japanese
> paragraphs.  In this case, U+3000 should be kept, but I doubt we use
> halfwidth-* functions for such style Japanese text.
> 
> IMO, I expected halfwidth-* functions to convert U+3000 to SPACE as
> japanese-hankaku did.  But other Japanese said both behaviors whould
> be in demand.  I don't know about other languages.

OK, for now I added the conversion of SPC to IDEOGRAPHIC SPACE.  Let's
see if people complain.

Thanks.'